<template>
  <div class="ele-body">
    <el-card shadow="never">
      <!-- 搜索表单 -->
      <user-search @search="reload" />
      <!-- 数据表格 -->
      <ele-pro-table ref="table" :columns="columns" :datasource="datasource" :selection.sync="selection" row-key="code">
        <!-- 表头工具栏 -->
        <template v-slot:toolbar>
          <el-button size="small" type="primary" icon="el-icon-plus" class="ele-btn-icon" @click="openEdit()">
            新建
          </el-button>
          <!-- <el-button
            size="small"
            type="danger"
            icon="el-icon-delete"
            class="ele-btn-icon"
            @click="removeBatch"
          >
            删除
          </el-button> -->
        </template>

        <template v-slot:status="{ row }">
          {{ checkType(row.categoryType) }}
        </template>
        <!-- 状态列 -->

        <!-- 操作列 -->
        <template v-slot:action="{ row }">
          <el-link type="primary" :underline="false" icon="el-icon-edit" @click="openEdit(row)">
            修改
          </el-link>

          <el-popconfirm class="ele-action" title="确定要删除当前参数吗？" @confirm="remove(row)">
            <template v-slot:reference>
              <el-link type="danger" :underline="false" icon="el-icon-delete">
                删除
              </el-link>
            </template>
          </el-popconfirm>
        </template>
      </ele-pro-table>
    </el-card>
    <!-- 编辑弹窗 -->
    <user-edit :visible.sync="showEdit" :data="current" @done="reload" ref="userEdit" />
    <!-- 导入弹窗 -->
  </div>
</template>

<script>
import UserSearch from './components/user-search.vue';
import UserEdit from './components/user-edit.vue';

import parameter from '@/api/technology/productParam';

export default {
  name: 'productParam',
  components: {
    UserSearch,
    UserEdit
  },
  data() {
    return {
      // 表格列配置
      columns: [
   

        {
          prop: 'categoryCode',
          label: '产品编码',
          align: 'center',
          showOverflowTooltip: true
        },
        {
          prop: 'categoryName',
          label: '产品名称',
          align: 'center',
          showOverflowTooltip: true
        },
        {
          prop: 'categoryBrandNum',
          label: '牌号',
          align: 'center',
          showOverflowTooltip: true
        },
        {
          prop: 'categoryModelType',
          label: '型号',
          align: 'center',
          showOverflowTooltip: true
        },

        {
          prop: 'categoryMrpType',
          label: 'MRP代码',
          align: 'center',
          showOverflowTooltip: true
        },


        {
          prop: 'produceVersionName',
          label: '生产版本',
          align: 'center',
          showOverflowTooltip: true
        },


        {
          columnKey: 'action',
          label: '操作',
          width: 220,
          align: 'center',
          resizable: false,
          slot: 'action',
          showOverflowTooltip: true
        }
      ],
      statusList: [
        { label: '工艺', value: 0 },
        { label: '工序', value: 1 },
        { label: '产品', value: 2 },
        { label: '原料', value: 3 },
        { label: '设备', value: 4 },
        { label: '其他', value: 5 }
      ],
      // 表格选中数据
      selection: [],
      // 当前编辑数据
      current: null,
      // 是否显示编辑弹窗
      showEdit: false,
      // 是否显示导入弹窗
      showImport: false
    };
  },
  methods: {
    /*回显类型 */
    checkType(id) {
      const obj = this.statusList.find((item) => item.value == id);
      return obj.label;
    },
    /* 表格数据源 */
    async datasource({ page, limit, where, order }) {
      const res = await parameter.list({
        ...where,
        ...order,
        pageNum: page,
        size: limit
      });
      return res;
    },

    /* 刷新表格 */
    reload(where) {
      this.$refs.table.reload({ page: 1, where: where });
    },
    /* 打开编辑弹窗 */
    openEdit(row) {
      this.current = row;
      this.showEdit = true;
      this.$refs.userEdit.$refs.form &&
        this.$refs.userEdit.$refs.form.clearValidate();
    },

    /* 删除 */
    remove(row) {
      const loading = this.$loading({ lock: true });

      parameter
        .delete([row.id])
        .then((msg) => {
          loading.close();
          this.$message.success('删除' + msg);
          this.reload();
        })
        .catch((e) => {
          loading.close();
          // this.$message.error(e.message);
        });
    },
    /* 批量删除 */
    removeBatch() {
      if (!this.selection.length) {
        this.$message.error('请至少选择一条数据');
        return;
      }
      this.$confirm('确定要删除选中的工序吗?', '提示', {
        type: 'warning'
      })
        .then(() => {
          const loading = this.$loading({ lock: true });
          parameter
            .delete(this.selection.map((d) => d.id))
            .then((msg) => {
              loading.close();
              this.$message.success('删除' + msg);
              this.reload();
            })
            .catch((e) => {
              loading.close();
              // this.$message.error(e.message);
            });
        })
        .catch(() => { });
    }
  }
};
</script>
